function add_poles
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
poles_hndl = findobj ( gcbf , 'Tag' , 'push_add_poles');
zeros_hndl = findobj ( gcbf , 'Tag' , 'push_add_zeros');
axes_hndl = findobj ( gcbf , 'Tag' , 'axes_main');
box_hndl = findobj ( gcbf , 'Tag' , 'box_conj');
spcl_freq_hndl = findobj ( gcbf , 'Tag' , 'push_freq');


poles = get (poles_hndl , 'Userdata');
zeros = get (zeros_hndl , 'Userdata');

hold on; 
[h_zeros, h_poles, h_axis] = zplane ( zeros , poles);
axis([-1.25 1.25 -1.25 1.25]);
set(h_poles,'MarkerSize',11);

x_limits =  get (axes_hndl , 'XLim') ;%find x-axis limits
y_limits =  get (axes_hndl , 'YLim'); %find y-axis limits


use_conj = get (box_hndl , 'Value');

while (1)
   [x y] = ginput(1);
      
   if ( x < x_limits(1) | x > x_limits(2) | y < y_limits(1) | y > x_limits(2)  )
      break;
   end
   
   x = floor ( x* 100) /100;
   y = floor ( y * 100) /100;
   z = [x + j*y];
   
   %Disable freq response if poles lie outside unit cirlce
   if (abs(z) > 1)
      set(spcl_freq_hndl,'Enable','off');
   end
   
   
   if ( use_conj & y ~= 0) 
      poles = [ poles ; z ; conj(z) ];
   else
      poles = [poles; z ];
   end
   
   hold on;
  	[h_zeros, h_poles, h_axis] = zplane ( zeros , poles);
    axis([-1.25 1.25 -1.25 1.25]);
    set(h_poles,'MarkerSize',11);

    set( poles_hndl , 'Userdata' , poles);

end
      
   

   

   
   
   